
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% FDS.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [point,info] = FDS(fun,point,step,par,tune,info)
% repeatedly impove function value by Delta
%
% for details of input and output structures see VSBBO.m
%
function [point,info] = FDS(fun,point,step,par,tune,info)

ngood = 0;

while 1
       [point,par,step,info] = MLS(fun,point,step,par,tune,info);
       if info.done, return; end;
       if info.prt>=0, nfFDS=info.nf, end;
       if ~ par.good
          if info.prt>=0,
              disp('FDS cannot find an improvement on function value')
              disp(['point.fr = ',num2str(point.fr), ...
                    ' point.fm = ',num2str(point.fm)]);
          end
          break; 
       end
        
       ngood = ngood+1;
end
info.ngood = ngood;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
