
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% direction.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [step,par] = direction(point,step,par,tune,info)
% generate subspace, random and cumulative directions
%
% for details of input and output structures see VSBBO.m
%
function [step,par] = direction(point,step,par,tune,info)

switch par.dir
   case 1 % heuristic direction
        step.p = rand(point.n,1)-0.5;
        step.p(step.p==0) = 0.5; 
        nmax = max(point.n,100);
        par.tt  = randi([1 nmax],1);
        par.hss = nmax/(nmax+tune.gamma8*par.tt);
        step.p  = par.hss*step.p;
        scale   = 1;
   case 2 % subspace direction
        alpha = rand(point.m,1)-0.5;
        alpha=alpha*(tune.gamma5/norm(alpha));
        for i=1:point.m
            dX(:,i) = alpha(i)*(point.X(:,i)-point.X(:,point.b));
        end
        step.p=sum(dX')'; 
        if norm(step.p)==0
            step.p= rand(point.n,1)-0.5; step.p(step.p==0) = 0.5;
        end
        scale = tune.scSub;
   case 3 % random direction
        step.p = rand(point.n,1)-0.5;
        step.p(step.p==0) = 0.5; scale = 1;
   case 4 % cumulative direction
        step.p=step.q; scale = tune.scCum;
  
end

if scale % scale to ||p||=delta
    if par.lam==0, par.lam=1; end
     
     step.delta = max(step.deltamin,...
            min(sqrt(tune.gamma1*step.Delta/par.lam),step.deltamax));
     if info.prt>=0 & par.lam >= 1000, step.delta,  end
else
    step.dp = norm(step.p);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
